'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.

'REV 1.1, Fixed bug to correct for range other than bip10volts.

Imports VB = Microsoft.VisualBasic
Imports System.Runtime.InteropServices
Public Class Form1

    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo
    Dim AOStatus, UserStatus As Boolean
    Public MHandle As System.IntPtr
    Dim MulitArrayNumPoints As Integer
    Dim FirstPoint As Integer
    Public ADDataV(,) As Single
    Dim CurIndex As Integer
    Dim CurCount As Integer
    Dim AOOptions As MccDaq.ScanOptions = MccDaq.ScanOptions.Default
    Dim DataArray() As UShort
    Dim NumPoints As Integer
    Dim AORate As Int32
    Dim Range As MccDaq.Range
    Dim CurrentChannel As Integer
    Dim WaveType As Integer

    Private scope As BERGtools.Oscilloscope
    Private FuncGen As BERGtools.FunctionGenerator

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim BoardNum As Integer
        Dim Numboards As Integer = 99

        Dim Boardfound As Boolean = False

        Me.Show()
        MsgBox("This program demonstrates analog output streaming," _
              + Chr(13) + "using Background + Continuous mode on 1 or more channels" _
              + Chr(13) + "Boards supported for this program include, but not limited to:" _
              + Chr(13) _
              + Chr(13) + "                       USB-3101FS," _
              + Chr(13) + "                       USB-1608GX-2AO," _
              + Chr(13) + "                       USB-2527," _
              + Chr(13) + "                       USB-2537," _
              + Chr(13) + "                       PCI-DAS6040," _
              + Chr(13) + "                       PCI-DAS6070," _
              + Chr(13) + "                       PCI-2515," _
              + Chr(13) + "                       PCI-2517," _
              + Chr(13) + "                       USB-1208HS-2AO," _
              + Chr(13) + "                       USB-1208HS-4AO," _
              + Chr(13) + "                       USB-1616HS-4," _
              + Chr(13) + "                       USB-1616HS-2," _
              + Chr(13) + "                       USB-1616HS-BNC," _
              + Chr(13) + "                       USB-1608HS-2AO," _
              + Chr(13) + "                       USB-1604HS-2AO," _
              + Chr(13) + "                       USB-1602HS-2AO" _
              + Chr(13) + "                       USB-1208FS," _
              + Chr(13) + "                       USB-1208FS-PLUS," _
              + Chr(13) + "                       USB-1408FS," _
              + Chr(13) + "                       USB-1408FS-PLUS," _
              + Chr(13) + "                       USB-7204." _
              + Chr(13) _
              + Chr(13) + Chr(10) + "To use other analog output devices, you will need to modify the form Load event" _
              , MsgBoxStyle.OkOnly, "Measurement Computing Sample Program")

        Me.Show()
        Me.Cursor = Cursors.WaitCursor

        Range = MccDaq.Range.Bip10Volts 'use this as default.

        For BoardNum = 0 To Numboards - 1
            Daqboard = New MccDaq.MccBoard(BoardNum)
            If Daqboard.BoardName.Contains("USB-2537") Then
                Boardfound = True
                Me.Text = "USB-2537 found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-2527") Then
                Boardfound = True
                Me.Text = "USB-2527 found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("PCI-2515") Then
                Boardfound = True
                Me.Text = "PCI-2515 found as board number: " + BoardNum.ToString
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("PCI-2517") Then
                Boardfound = True
                Me.Text = "PCI-2517 found as board number: " + BoardNum.ToString
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("PCI-DAS6040") Then
                Boardfound = True
                Me.Text = "PCI-DAS6040 found as board number: " + BoardNum.ToString
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("PCI-DAS6070") Then
                Boardfound = True
                Me.Text = "PCI-DAS6070 found as board number: " + BoardNum.ToString
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1208HS-2AO") Then
                Boardfound = True
                Me.Text = "USB-1208HS-2AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1208HS-4AO") Then
                Boardfound = True
                Me.Text = "USB-1208HS-4AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1608HS-2AO") Then
                Boardfound = True
                Me.Text = "USB-1608HS-2AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1604HS-2AO") Then
                Boardfound = True
                Me.Text = "USB-1604HS-2AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1602HS-2AO") Then
                Boardfound = True
                Me.Text = "USB-1602HS-2AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If


            If Daqboard.BoardName.Contains("USB-1616HS-2") Then
                Boardfound = True
                Me.Text = "USB-1616HS-2 found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1616HS-BNC") Then
                Boardfound = True
                Me.Text = "USB-1616HS-BNC found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1616HS-4") Then
                Boardfound = True
                Me.Text = "USB-1616HS-4 found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-3101FS") Then
                Boardfound = True
                Me.Text = "USB-3101FS found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 4
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1608GX-2AO") Then
                Boardfound = True
                Me.Text = "USB-1608GX-2AO found as board number: " + BoardNum.ToString
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Exit For
            End If


            If Daqboard.BoardName.Contains("USB-1208FS") Then
                Boardfound = True
                Me.Text = "USB-1208FS found as board number: " + BoardNum.ToString
                txtAORate.Text = 5000
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Range = MccDaq.Range.Uni4Volts
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-7204") Then
                Boardfound = True
                Me.Text = "USB-7204 found as board number: " + BoardNum.ToString
                txtAORate.Text = 5000
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Range = MccDaq.Range.Uni4Volts
                Exit For
            End If

            If Daqboard.BoardName.Contains("USB-1408FS") Then
                Boardfound = True
                Me.Text = "USB-1408FS found as board number: " + BoardNum.ToString
                txtAORate.Text = 5000
                Daqboard.FlashLED()
                Me.nudChannelNumber.Maximum = 2
                Range = MccDaq.Range.Uni4Volts
                Exit For
            End If
        Next

        If Me.nudChannelNumber.Maximum = 2 Then
            Me.GroupBox3.Enabled = False
            Me.GroupBox4.Enabled = False
        End If

        Me.Cursor = Cursors.Default

        If Boardfound = False Then
            MsgBox("No compatible device found in system.  Please run InstaCal.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        scope = New BERGtools.Oscilloscope()
        scope.Initialize(PictureBox1)
        scope.TraceColor(0, Color.Red)
        scope.TraceColor(1, Color.White)
        scope.TraceColor(2, Color.Green)
        scope.TraceColor(3, Color.Black)
        scope.YScale(-10, 10, 10)
        scope.DrawBackground()

        FuncGen = New BERGtools.FunctionGenerator

    End Sub

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo, ByVal MyEvent As String)
        'Generic UL error handler
        lblMode.Text = "Idle"
        btnStartStop.Text = "Start"
        Timer2.Enabled = False
        MessageBox.Show(ulstat.Message, "Universal Library Error in " + MyEvent + " Event", _
                   MessageBoxButtons.OK, MessageBoxIcon.Error)
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AoFunction)
        ulstat = MccDaq.MccService.WinBufFreeEx(MHandle) ' Free up memory for use by other programs

    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        btnStartStop.Text = "Start"
        AOStatus = False
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AoFunction)
        lblMode.Text = "Idle"
        ulstat = MccDaq.MccService.WinBufFreeEx(MHandle) ' Free up memory for use by other programs
        End
    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            AOStatus = True
            Me.Refresh()
            ' 
            UserStatus = True
            Call RunDacs()   '
        Else
            btnStartStop.Text = "Start"
            UserStatus = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AoFunction)
            lblMode.Text = "Idle"
            ulstat = MccDaq.MccService.WinBufFreeEx(MHandle) ' Free up memory for use by other programs
        End If
    End Sub
    Public Function WaveSelect(ByVal CurrentChannel As Integer) As BERGtools.WaveType
        Select Case CurrentChannel
            Case 0
                If rbSquareWave.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Square
                ElseIf rbRampWave.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Ramp
                ElseIf rbNoiseWave.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Noise
                ElseIf rbTriangleWave.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Triangle
                Else
                    WaveSelect = BERGtools.WaveType.Sine
                End If
            Case 1
                If rbSquareWave1.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Square
                ElseIf rbRampWave1.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Ramp
                ElseIf rbNoiseWave1.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Noise
                ElseIf rbTriangleWave1.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Triangle
                Else
                    WaveSelect = BERGtools.WaveType.Sine
                End If

            Case 2
                If rbSquareWave2.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Square
                ElseIf rbRampWave2.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Ramp
                ElseIf rbNoiseWave2.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Noise
                ElseIf rbTriangleWave2.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Triangle
                Else
                    WaveSelect = BERGtools.WaveType.Sine
                End If

            Case 3
                If rbSquareWave3.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Square
                ElseIf rbRampWave3.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Ramp
                ElseIf rbNoiseWave3.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Noise
                ElseIf rbTriangleWave3.Checked = True Then
                    WaveSelect = BERGtools.WaveType.Triangle
                Else
                    WaveSelect = BERGtools.WaveType.Sine
                End If

        End Select
    End Function

    Public Sub CreateWave()  'Here we are generating the type of waveform to output. 
        Dim MaxDacValue, DCOffset As Int16
        Dim IsValidNumber As Boolean = True

        Try   'test to verify txtPointsPerWaveform is a valid number
            NumPoints = Single.Parse(txtPointsPerWaveform.Text)
            MulitArrayNumPoints = (NumPoints) * nudChannelNumber.Value 'this is the interleaved 1D array, needed by UL
            ReDim DataArray(NumPoints * nudChannelNumber.Value - 1) 'this is the 2D array in counts (UShorts)
        Catch
            MessageBox.Show(txtPointsPerWaveform.Text + " is not a valid Points/waveform", "Invalid Points/waveform ", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
            IsValidNumber = False
            btnStartStop.Text = "Start"
        End Try

        If IsValidNumber Then
            Try  'test to verifytxtAmplitude is a valid number
                MaxDacValue = Single.Parse(txtAmplitude.Text)

            Catch
                MessageBox.Show(txtAmplitude.Text + " is not a valid Amplitude", "Invalid Amplitude ", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
                IsValidNumber = False
                btnStartStop.Text = "Start"
            End Try
        End If

        If IsValidNumber Then
            Try  'test to verify txtOffset is a valid number
                DCOffset = Single.Parse(txtOffset.Text)

            Catch
                MessageBox.Show(txtOffset.Text + " is not a valid Offset", "Invalid Offset ", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
                IsValidNumber = False
                btnStartStop.Text = "Start"
            End Try
        End If

        If IsValidNumber Then
            Try  'test to verify txtAORate is a valid number
                AORate = Int32.Parse(txtAORate.Text)
                AORate = AORate
            Catch
                MessageBox.Show(txtAORate.Text + " is not a valid Rate", "Invalid Rate ", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
                IsValidNumber = False
                btnStartStop.Text = "Start"
                Timer2.Enabled = False
                Exit Sub
            End Try
        End If

        If IsValidNumber Then
            FuncGen.Initialize(nudChannelNumber.Value)

            For CurrentChannel = 0 To nudChannelNumber.Value - 1
                WaveType = WaveSelect(CurrentChannel)
                FuncGen.WaveSelect(WaveType, CurrentChannel, 5)
                FuncGen.PointsPerPeriod(NumPoints, CurrentChannel)
                FuncGen.amplitude(MaxDacValue, CurrentChannel)
                FuncGen.offset(DCOffset, CurrentChannel)
                FuncGen.DutyCycle(50, CurrentChannel)
            Next
            ADDataV = FuncGen.CreateWave()
            scope.UpdateScope(ADDataV)

            Dim Rows As Integer = ADDataV.Length

            Dim MasterIndex As Integer = 0
            Dim MyIndex As Integer
            For MyIndex = 0 To NumPoints - 1
                For CurrentChannel = 0 To nudChannelNumber.Value - 1

                    ulstat = Daqboard.FromEngUnits(Range, ADDataV(CurrentChannel, MyIndex), DataArray(MasterIndex))
                    MasterIndex += 1
                Next
            Next


            MHandle = MccDaq.MccService.WinBufAllocEx(MulitArrayNumPoints) ' set aside memory to hold data
            If MHandle = 0 Then Stop

            FirstPoint = 0

            'move the array out to computer memory
            ulstat = MccDaq.MccService.WinArrayToBuf(DataArray, MHandle, FirstPoint, MulitArrayNumPoints)

            'Set scan options
            AOOptions = MccDaq.ScanOptions.Background
            If chkAOContinuous.Checked Then AOOptions += MccDaq.ScanOptions.Continuous
            If chkADCCLOCK.Checked Then AOOptions += MccDaq.ScanOptions.ADCClock
            If chkADCClockTrig.Checked Then AOOptions += MccDaq.ScanOptions.ADCClockTrig
            If chkNonStreamedIO.Checked Then AOOptions += MccDaq.ScanOptions.NonStreamedIO
            If chkExtClock.Checked Then AOOptions += MccDaq.ScanOptions.ExtClock

        End If
    End Sub

    Public Sub RunDacs()        'Look here to see how to Load the array, set options and start the scan

        Me.lblMode.Text = "Running"
        Dim HighChan As Integer = nudChannelNumber.Value - 1
        Call CreateWave()

        ulstat = Daqboard.AOutScan(0, HighChan, MulitArrayNumPoints, AORate, Range, MHandle, AOOptions)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat, "RunDacs")
        End If

        ulstat = Daqboard.GetStatus(AOStatus, CurCount, CurIndex, MccDaq.FunctionType.AoFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat, "RunDacs")
        End If

        'once the scan is running, check the timer for status.
        Timer2.Enabled = True

    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        'Look here to check the status of the scan.
        'You can check to see if it's still running from the Status parameter (True = running)
        'Current Count will tell you the number of samples you have output (totalizer)
        'Current Index will tell you where you are in your array. 
        'Note that if the array is one packet in length, you will never see it change.
        ulstat = Daqboard.GetStatus(AOStatus, CurCount, CurIndex, MccDaq.FunctionType.AoFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat, "Timer2_Tick")
        End If
        lblCurIndex.Text = CurIndex.ToString()
        lblCurIndex.Refresh()

        'If you are running in Background only, status will change to false as soon
        'as the CurIndex = numpoints (length of the buffer)
        'In Foreground mode, this event is not necessary as the program will wait until the scan completes.
        If AOStatus = False Or UserStatus = False Then
            Timer2.Enabled = False
            AOStatus = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AoFunction)
            lblMode.Text = "Idle"
        End If
    End Sub

End Class
